/* Keyring.c generated by valac 0.39.7, the Vala compiler
 * generated from Keyring.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2016 elementary LLC.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* This is compatible with Ubuntu Online Accounts.*/

#include <glib.h>
#include <glib-object.h>
#include <gsignond/gsignond-secret-storage.h>
#include <libsecret/secret.h>
#include <gsignond/gsignond-credentials.h>
#include <gsignond/gsignond-dictionary.h>
#include <stdlib.h>
#include <string.h>


#define ONLINE_ACCOUNTS_TYPE_KEYRING (online_accounts_keyring_get_type ())
#define ONLINE_ACCOUNTS_KEYRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyring))
#define ONLINE_ACCOUNTS_KEYRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyringClass))
#define ONLINE_ACCOUNTS_IS_KEYRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_KEYRING))
#define ONLINE_ACCOUNTS_IS_KEYRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_KEYRING))
#define ONLINE_ACCOUNTS_KEYRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyringClass))

typedef struct _OnlineAccountsKeyring OnlineAccountsKeyring;
typedef struct _OnlineAccountsKeyringClass OnlineAccountsKeyringClass;
typedef struct _OnlineAccountsKeyringPrivate OnlineAccountsKeyringPrivate;
enum  {
	ONLINE_ACCOUNTS_KEYRING_0_PROPERTY,
	ONLINE_ACCOUNTS_KEYRING_NUM_PROPERTIES
};
static GParamSpec* online_accounts_keyring_properties[ONLINE_ACCOUNTS_KEYRING_NUM_PROPERTIES];

#define ONLINE_ACCOUNTS_KEYRING_TYPE_SIGNON_SECRET_TYPE (online_accounts_keyring_signon_secret_type_get_type ())
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _OnlineAccountsKeyring {
	GSignondSecretStorage parent_instance;
	OnlineAccountsKeyringPrivate * priv;
};

struct _OnlineAccountsKeyringClass {
	GSignondSecretStorageClass parent_class;
};

struct _OnlineAccountsKeyringPrivate {
	SecretSchema* schema;
	GError* error;
};

typedef enum  {
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_NOTYPE = 0,
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD,
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME,
	ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA
} OnlineAccountsKeyringSignonSecretType;


static gpointer online_accounts_keyring_parent_class = NULL;

GType online_accounts_keyring_get_type (void) G_GNUC_CONST;
#define ONLINE_ACCOUNTS_KEYRING_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyringPrivate))
GType online_accounts_keyring_signon_secret_type_get_type (void) G_GNUC_CONST;
static gboolean online_accounts_keyring_real_open_db (GSignondSecretStorage* base);
static gboolean online_accounts_keyring_real_close_db (GSignondSecretStorage* base);
static gboolean online_accounts_keyring_real_clear_db (GSignondSecretStorage* base);
static gboolean online_accounts_keyring_real_is_open_db (GSignondSecretStorage* base);
static GSignondCredentials* online_accounts_keyring_real_load_credentials (GSignondSecretStorage* base,
                                                                    guint32 id);
gboolean online_accounts_keyring_load_secret (OnlineAccountsKeyring* self,
                                              OnlineAccountsKeyringSignonSecretType type,
                                              guint32 id,
                                              guint32 method,
                                              gchar* * secret);
static gboolean online_accounts_keyring_real_update_credentials (GSignondSecretStorage* base,
                                                          GSignondCredentials* creds);
gboolean online_accounts_keyring_store_secret (OnlineAccountsKeyring* self,
                                               OnlineAccountsKeyringSignonSecretType type,
                                               guint32 id,
                                               guint32 method,
                                               const gchar* secret);
static gboolean online_accounts_keyring_real_remove_credentials (GSignondSecretStorage* base,
                                                          guint32 id);
static gboolean online_accounts_keyring_real_check_credentials (GSignondSecretStorage* base,
                                                         GSignondCredentials* creds);
static GSignondDictionary* online_accounts_keyring_real_load_data (GSignondSecretStorage* base,
                                                            guint32 id,
                                                            guint32 method);
static gboolean online_accounts_keyring_real_update_data (GSignondSecretStorage* base,
                                                   guint32 id,
                                                   guint32 method,
                                                   GSignondDictionary* data);
static gboolean online_accounts_keyring_real_remove_data (GSignondSecretStorage* base,
                                                   guint32 id,
                                                   guint32 method);
static GError* online_accounts_keyring_real_get_last_error (GSignondSecretStorage* base);
gboolean online_accounts_keyring_store_password (OnlineAccountsKeyring* self,
                                                 gint type,
                                                 gint id,
                                                 gint method,
                                                 const gchar* password);
OnlineAccountsKeyring* online_accounts_keyring_new (void);
OnlineAccountsKeyring* online_accounts_keyring_construct (GType object_type);
static void online_accounts_keyring_finalize (GObject * obj);


GType
online_accounts_keyring_signon_secret_type_get_type (void)
{
	static volatile gsize online_accounts_keyring_signon_secret_type_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_keyring_signon_secret_type_type_id__volatile)) {
		static const GEnumValue values[] = {{ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_NOTYPE, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_NOTYPE", "notype"}, {ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD", "password"}, {ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME", "username"}, {ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA, "ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA", "data"}, {0, NULL, NULL}};
		GType online_accounts_keyring_signon_secret_type_type_id;
		online_accounts_keyring_signon_secret_type_type_id = g_enum_register_static ("OnlineAccountsKeyringSignonSecretType", values);
		g_once_init_leave (&online_accounts_keyring_signon_secret_type_type_id__volatile, online_accounts_keyring_signon_secret_type_type_id);
	}
	return online_accounts_keyring_signon_secret_type_type_id__volatile;
}


static gboolean
online_accounts_keyring_real_open_db (GSignondSecretStorage* base)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	SecretSchema* _tmp0_;
#line 34 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 35 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = self->priv->schema;
#line 35 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp0_ == NULL) {
#line 158 "Keyring.c"
		SecretSchema* _tmp1_;
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp1_ = secret_schema_new ("org pantheon.OnlineAccounts.Secrets", SECRET_SCHEMA_DONT_MATCH_NAME, "signon-type", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "signon-id", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "signon-method", SECRET_SCHEMA_ATTRIBUTE_INTEGER, NULL);
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_secret_schema_unref0 (self->priv->schema);
#line 36 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->schema = _tmp1_;
#line 166 "Keyring.c"
	}
#line 42 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 42 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 172 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_close_db (GSignondSecretStorage* base)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
#line 45 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 46 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 46 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 187 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_clear_db (GSignondSecretStorage* base)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
#line 49 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 50 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 202 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_is_open_db (GSignondSecretStorage* base)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	SecretSchema* _tmp0_;
#line 53 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 54 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = self->priv->schema;
#line 54 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _tmp0_ != NULL;
#line 54 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 220 "Keyring.c"
}


static GSignondCredentials*
online_accounts_keyring_real_load_credentials (GSignondSecretStorage* base,
                                               guint32 id)
{
	OnlineAccountsKeyring * self;
	GSignondCredentials* result = NULL;
	GSignondCredentials* credidential = NULL;
	GSignondCredentials* _tmp0_;
	gchar* username = NULL;
	gchar* password = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 57 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 58 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = gsignond_credentials_new ();
#line 58 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	credidential = _tmp0_;
#line 61 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_load_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME, id, (guint32) 0, &_tmp1_);
#line 61 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (username);
#line 61 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	username = _tmp1_;
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_load_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD, id, (guint32) 0, &_tmp2_);
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (password);
#line 62 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	password = _tmp2_;
#line 63 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	gsignond_credentials_set_data (credidential, id, username, password);
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = credidential;
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (password);
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (username);
#line 64 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 264 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_update_credentials (GSignondSecretStorage* base,
                                                 GSignondCredentials* creds)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	guint32 id = 0U;
	gchar* password = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* username = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
#line 67 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 67 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (creds != NULL, FALSE);
#line 68 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	id = gsignond_credentials_get_id (creds);
#line 69 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = gsignond_credentials_get_password (creds);
#line 69 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 69 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	password = _tmp1_;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp3_ = password;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp3_ != NULL) {
#line 301 "Keyring.c"
		const gchar* _tmp4_;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = password;
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 307 "Keyring.c"
	} else {
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = FALSE;
#line 311 "Keyring.c"
	}
#line 70 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp2_) {
#line 315 "Keyring.c"
		guint32 _tmp5_;
		const gchar* _tmp6_;
#line 71 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = id;
#line 71 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = password;
#line 71 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (!online_accounts_keyring_store_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_PASSWORD, _tmp5_, (guint32) 0, _tmp6_)) {
#line 72 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			result = FALSE;
#line 72 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (password);
#line 72 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			return result;
#line 330 "Keyring.c"
		}
	}
#line 76 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp7_ = gsignond_credentials_get_username (creds);
#line 76 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 76 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	username = _tmp8_;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp10_ = username;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp10_ != NULL) {
#line 343 "Keyring.c"
		const gchar* _tmp11_;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp11_ = username;
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = g_strcmp0 (_tmp11_, "") != 0;
#line 349 "Keyring.c"
	} else {
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = FALSE;
#line 353 "Keyring.c"
	}
#line 77 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp9_) {
#line 357 "Keyring.c"
		guint32 _tmp12_;
		const gchar* _tmp13_;
#line 78 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp12_ = id;
#line 78 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp13_ = username;
#line 78 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (!online_accounts_keyring_store_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_USERNAME, _tmp12_, (guint32) 0, _tmp13_)) {
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			result = FALSE;
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (username);
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (password);
#line 79 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			return result;
#line 374 "Keyring.c"
		}
	}
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (username);
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (password);
#line 83 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 385 "Keyring.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return self ? g_error_copy (self) : NULL;
#line 394 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_remove_credentials (GSignondSecretStorage* base,
                                                 guint32 id)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 408 "Keyring.c"
	{
		gboolean _tmp0_ = FALSE;
		SecretSchema* _tmp1_;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp1_ = self->priv->schema;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = secret_password_clear_sync (_tmp1_, NULL, &_inner_error_, "signon-id", id, NULL);
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 418 "Keyring.c"
			goto __catch0_g_error;
		}
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _tmp0_;
#line 88 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 425 "Keyring.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = e;
#line 90 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = _tmp2_->message;
#line 90 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:90: %s", _tmp3_);
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = e;
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 91 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp5_;
#line 92 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 92 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 92 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 459 "Keyring.c"
	}
	__finally0:
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_clear_error (&_inner_error_);
#line 87 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return _tmp6_;
#line 468 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_check_credentials (GSignondSecretStorage* base,
                                                GSignondCredentials* creds)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
#line 96 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 96 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (creds != NULL, FALSE);
#line 97 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = GSIGNOND_SECRET_STORAGE_CLASS (online_accounts_keyring_parent_class)->check_credentials (G_TYPE_CHECK_INSTANCE_CAST (self, gsignond_secret_storage_get_type (), GSignondSecretStorage), creds);
#line 97 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 486 "Keyring.c"
}


static GSignondDictionary*
online_accounts_keyring_real_load_data (GSignondSecretStorage* base,
                                        guint32 id,
                                        guint32 method)
{
	OnlineAccountsKeyring * self;
	GSignondDictionary* result = NULL;
	GSignondDictionary* _result_ = NULL;
	GSignondDictionary* _tmp0_;
	gchar* data_serialized = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 100 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 101 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = gsignond_dictionary_new ();
#line 101 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_result_ = _tmp0_;
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_load_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA, id, method, &_tmp1_);
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (data_serialized);
#line 103 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	data_serialized = _tmp1_;
#line 104 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp2_ = data_serialized;
#line 104 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp2_ == NULL) {
#line 105 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _result_;
#line 105 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (data_serialized);
#line 105 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 525 "Keyring.c"
	}
	{
		GVariant* variant = NULL;
		const gchar* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GSignondDictionary* _tmp6_;
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = data_serialized;
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = g_variant_parse (NULL, _tmp3_, NULL, NULL, &_inner_error_);
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		variant = _tmp4_;
#line 109 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 541 "Keyring.c"
			goto __catch1_g_error;
		}
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = variant;
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = gsignond_dictionary_new_from_variant (_tmp5_);
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_hash_table_unref0 (_result_);
#line 110 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_result_ = _tmp6_;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_variant_unref0 (variant);
#line 554 "Keyring.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 112 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = e;
#line 112 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = _tmp7_->message;
#line 112 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:112: %s", _tmp8_);
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = e;
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = _g_error_copy0 (_tmp9_);
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 113 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp10_;
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 584 "Keyring.c"
	}
	__finally1:
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (data_serialized);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_hash_table_unref0 (_result_);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return NULL;
#line 599 "Keyring.c"
	}
#line 116 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _result_;
#line 116 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (data_serialized);
#line 116 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 607 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_update_data (GSignondSecretStorage* base,
                                          guint32 id,
                                          guint32 method,
                                          GSignondDictionary* data)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	gchar* secret = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 119 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 119 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = gsignond_dictionary_to_variant (data);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = _tmp0_;
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp2_ = g_variant_print (_tmp1_, TRUE);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp3_ = _tmp2_;
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp4_ = g_strdup_printf ("%s", _tmp3_);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp5_ = _tmp4_;
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (_tmp3_);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_variant_unref0 (_tmp1_);
#line 120 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	secret = _tmp5_;
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = online_accounts_keyring_store_secret (self, ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA, id, method, secret);
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (secret);
#line 121 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 654 "Keyring.c"
}


static gboolean
online_accounts_keyring_real_remove_data (GSignondSecretStorage* base,
                                          guint32 id,
                                          guint32 method)
{
	OnlineAccountsKeyring * self;
	gboolean result = FALSE;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
#line 124 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 669 "Keyring.c"
	{
		gboolean _tmp0_ = FALSE;
		SecretSchema* _tmp1_;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp1_ = self->priv->schema;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = secret_password_clear_sync (_tmp1_, NULL, &_inner_error_, "signon-id", id, "signon-method", method, NULL, NULL);
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 679 "Keyring.c"
			goto __catch2_g_error;
		}
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _tmp0_;
#line 126 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 686 "Keyring.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 128 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = e;
#line 128 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = _tmp2_->message;
#line 128 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:128: %s", _tmp3_);
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = e;
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 129 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp5_;
#line 130 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 130 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 130 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 720 "Keyring.c"
	}
	__finally2:
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_clear_error (&_inner_error_);
#line 125 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return _tmp6_;
#line 729 "Keyring.c"
}


static GError*
online_accounts_keyring_real_get_last_error (GSignondSecretStorage* base)
{
	OnlineAccountsKeyring * self;
	GError* result = NULL;
	GError* _tmp0_;
	GError* _tmp1_;
#line 134 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) base;
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp0_ = self->priv->error;
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = _g_error_copy0 (_tmp0_);
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = _tmp1_;
#line 135 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 750 "Keyring.c"
}


gboolean
online_accounts_keyring_store_password (OnlineAccountsKeyring* self,
                                        gint type,
                                        gint id,
                                        gint method,
                                        const gchar* password)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp7_ = FALSE;
	GError * _inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 138 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (password == NULL) {
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = TRUE;
#line 773 "Keyring.c"
	} else {
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = g_strcmp0 (password, "") == 0;
#line 777 "Keyring.c"
	}
#line 139 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp0_) {
#line 140 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 140 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 785 "Keyring.c"
	}
	{
		gboolean _tmp1_ = FALSE;
		SecretSchema* _tmp2_;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = self->priv->schema;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp1_ = secret_password_store_sync (_tmp2_, SECRET_COLLECTION_DEFAULT, "Online Account", password, NULL, &_inner_error_, "signon-type", type, "signon-id", id, "signon-method", method, NULL, NULL);
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 796 "Keyring.c"
			goto __catch3_g_error;
		}
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = _tmp1_;
#line 143 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 803 "Keyring.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 147 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = e;
#line 147 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = _tmp3_->message;
#line 147 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:147: %s", _tmp4_);
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = e;
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = _g_error_copy0 (_tmp5_);
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 148 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp6_;
#line 149 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 149 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 149 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 837 "Keyring.c"
	}
	__finally3:
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_clear_error (&_inner_error_);
#line 142 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return _tmp7_;
#line 846 "Keyring.c"
}


gboolean
online_accounts_keyring_store_secret (OnlineAccountsKeyring* self,
                                      OnlineAccountsKeyringSignonSecretType type,
                                      guint32 id,
                                      guint32 method,
                                      const gchar* secret)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* display_name = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* signonMethod = NULL;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
#line 153 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (secret != NULL, FALSE);
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (secret == NULL) {
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = TRUE;
#line 873 "Keyring.c"
	} else {
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = g_strcmp0 (secret, "") == 0;
#line 877 "Keyring.c"
	}
#line 154 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (_tmp0_) {
#line 155 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 155 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 885 "Keyring.c"
	}
#line 156 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = g_strdup_printf ("Online Account: id %u-%u", (guint) id, (guint) type);
#line 156 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	display_name = _tmp1_;
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (type == ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA) {
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = "signon-method";
#line 895 "Keyring.c"
	} else {
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = NULL;
#line 899 "Keyring.c"
	}
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 157 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	signonMethod = _tmp3_;
#line 905 "Keyring.c"
	{
		SecretSchema* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = self->priv->schema;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = display_name;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = signonMethod;
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		secret_password_store_sync (_tmp4_, SECRET_COLLECTION_DEFAULT, _tmp5_, secret, NULL, &_inner_error_, "signon-type", type, "signon-id", id, _tmp6_, method, NULL);
#line 159 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 920 "Keyring.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 164 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = e;
#line 164 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = _tmp7_->message;
#line 164 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("Keyring.vala:164: %s", _tmp8_);
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = e;
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = _g_error_copy0 (_tmp9_);
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 165 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp10_;
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (display_name);
#line 166 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 960 "Keyring.c"
	}
	__finally4:
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 965 "Keyring.c"
		gboolean _tmp11_ = FALSE;
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (display_name);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return _tmp11_;
#line 977 "Keyring.c"
	}
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (signonMethod);
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (display_name);
#line 169 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 987 "Keyring.c"
}


gboolean
online_accounts_keyring_load_secret (OnlineAccountsKeyring* self,
                                     OnlineAccountsKeyringSignonSecretType type,
                                     guint32 id,
                                     guint32 method,
                                     gchar* * secret)
{
	gchar* _vala_secret = NULL;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* signonMethod = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 172 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (type == ONLINE_ACCOUNTS_KEYRING_SIGNON_SECRET_TYPE_DATA) {
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = "signon-method";
#line 1010 "Keyring.c"
	} else {
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp0_ = NULL;
#line 1014 "Keyring.c"
	}
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 173 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	signonMethod = _tmp1_;
#line 1020 "Keyring.c"
	{
		gchar* data = NULL;
		SecretSchema* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp2_ = self->priv->schema;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp3_ = signonMethod;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp4_ = secret_password_lookup_sync (_tmp2_, NULL, &_inner_error_, "signon-type", type, "signon-id", id, _tmp3_, method, NULL);
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		data = _tmp4_;
#line 175 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1038 "Keyring.c"
			goto __catch5_g_error;
		}
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp5_ = data;
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (_vala_secret);
#line 178 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_vala_secret = _tmp6_;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (data);
#line 1051 "Keyring.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		e = _inner_error_;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_inner_error_ = NULL;
#line 180 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp7_ = e;
#line 180 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp8_ = _tmp7_->message;
#line 180 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_warning ("Keyring.vala:180: %s", _tmp8_);
#line 181 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (_vala_secret);
#line 181 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_vala_secret = NULL;
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp9_ = e;
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_tmp10_ = _g_error_copy0 (_tmp9_);
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (self->priv->error);
#line 182 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		self->priv->error = _tmp10_;
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		result = FALSE;
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_error_free0 (e);
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		if (secret) {
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			*secret = _vala_secret;
#line 1093 "Keyring.c"
		} else {
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
			_g_free0 (_vala_secret);
#line 1097 "Keyring.c"
		}
#line 183 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return result;
#line 1101 "Keyring.c"
	}
	__finally5:
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1106 "Keyring.c"
		gboolean _tmp11_ = FALSE;
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (signonMethod);
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		g_clear_error (&_inner_error_);
#line 174 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		return _tmp11_;
#line 1116 "Keyring.c"
	}
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	result = TRUE;
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_free0 (signonMethod);
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	if (secret) {
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		*secret = _vala_secret;
#line 1126 "Keyring.c"
	} else {
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
		_g_free0 (_vala_secret);
#line 1130 "Keyring.c"
	}
#line 186 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return result;
#line 1134 "Keyring.c"
}


OnlineAccountsKeyring*
online_accounts_keyring_construct (GType object_type)
{
	OnlineAccountsKeyring * self = NULL;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = (OnlineAccountsKeyring*) g_object_new (object_type, NULL);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return self;
#line 1146 "Keyring.c"
}


OnlineAccountsKeyring*
online_accounts_keyring_new (void)
{
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	return online_accounts_keyring_construct (ONLINE_ACCOUNTS_TYPE_KEYRING);
#line 1155 "Keyring.c"
}


static void
online_accounts_keyring_class_init (OnlineAccountsKeyringClass * klass)
{
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	online_accounts_keyring_parent_class = g_type_class_peek_parent (klass);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	g_type_class_add_private (klass, sizeof (OnlineAccountsKeyringPrivate));
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->open_db = (gboolean (*) (GSignondSecretStorage *)) online_accounts_keyring_real_open_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->close_db = (gboolean (*) (GSignondSecretStorage *)) online_accounts_keyring_real_close_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->clear_db = (gboolean (*) (GSignondSecretStorage *)) online_accounts_keyring_real_clear_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->is_open_db = (gboolean (*) (GSignondSecretStorage *)) online_accounts_keyring_real_is_open_db;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->load_credentials = (GSignondCredentials* (*) (GSignondSecretStorage *, guint32)) online_accounts_keyring_real_load_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->update_credentials = (gboolean (*) (GSignondSecretStorage *, GSignondCredentials*)) online_accounts_keyring_real_update_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->remove_credentials = (gboolean (*) (GSignondSecretStorage *, guint32)) online_accounts_keyring_real_remove_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->check_credentials = (gboolean (*) (GSignondSecretStorage *, GSignondCredentials*)) online_accounts_keyring_real_check_credentials;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->load_data = (GSignondDictionary* (*) (GSignondSecretStorage *, guint32, guint32)) online_accounts_keyring_real_load_data;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->update_data = (gboolean (*) (GSignondSecretStorage *, guint32, guint32, GSignondDictionary*)) online_accounts_keyring_real_update_data;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->remove_data = (gboolean (*) (GSignondSecretStorage *, guint32, guint32)) online_accounts_keyring_real_remove_data;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	((GSignondSecretStorageClass *) klass)->get_last_error = (GError* (*) (GSignondSecretStorage *)) online_accounts_keyring_real_get_last_error;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	G_OBJECT_CLASS (klass)->finalize = online_accounts_keyring_finalize;
#line 1192 "Keyring.c"
}


static void
online_accounts_keyring_instance_init (OnlineAccountsKeyring * self)
{
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self->priv = ONLINE_ACCOUNTS_KEYRING_GET_PRIVATE (self);
#line 32 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self->priv->schema = NULL;
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self->priv->error = NULL;
#line 1205 "Keyring.c"
}


static void
online_accounts_keyring_finalize (GObject * obj)
{
	OnlineAccountsKeyring * self;
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_KEYRING, OnlineAccountsKeyring);
#line 32 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_secret_schema_unref0 (self->priv->schema);
#line 33 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	_g_error_free0 (self->priv->error);
#line 24 "/builddir/build/BUILD/gsignond-extension-pantheon-0.3.0/src/Keyring.vala"
	G_OBJECT_CLASS (online_accounts_keyring_parent_class)->finalize (obj);
#line 1221 "Keyring.c"
}


GType
online_accounts_keyring_get_type (void)
{
	static volatile gsize online_accounts_keyring_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_keyring_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsKeyringClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_keyring_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsKeyring), 0, (GInstanceInitFunc) online_accounts_keyring_instance_init, NULL };
		GType online_accounts_keyring_type_id;
		online_accounts_keyring_type_id = g_type_register_static (gsignond_secret_storage_get_type (), "OnlineAccountsKeyring", &g_define_type_info, 0);
		g_once_init_leave (&online_accounts_keyring_type_id__volatile, online_accounts_keyring_type_id);
	}
	return online_accounts_keyring_type_id__volatile;
}



